<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref
 * ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref extends AbstractStructArrayBase
{
    /**
     * The CoveragePref
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref[]
     */
    public $CoveragePref;
    /**
     * Constructor method for ArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref
     * @uses DgArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref::setCoveragePref()
     * @param \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref[] $coveragePref
     */
    public function __construct(array $coveragePref = array())
    {
        $this
            ->setCoveragePref($coveragePref);
    }
    /**
     * Get CoveragePref value
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref[]|null
     */
    public function getCoveragePref()
    {
        return $this->CoveragePref;
    }
    /**
     * Set CoveragePref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref[] $coveragePref
     * @return \dgsoft\ArrayType\DgArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref
     */
    public function setCoveragePref(array $coveragePref = array())
    {
        foreach ($coveragePref as $arrayOfVehicleReservationRQAdditionalInfoTypeCoveragePrefCoveragePrefItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleReservationRQAdditionalInfoTypeCoveragePrefCoveragePrefItem instanceof \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref) {
                throw new \InvalidArgumentException(sprintf('The CoveragePref property can only contain items of \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref, "%s" given', is_object($arrayOfVehicleReservationRQAdditionalInfoTypeCoveragePrefCoveragePrefItem) ? get_class($arrayOfVehicleReservationRQAdditionalInfoTypeCoveragePrefCoveragePrefItem) : gettype($arrayOfVehicleReservationRQAdditionalInfoTypeCoveragePrefCoveragePrefItem)), __LINE__);
            }
        }
        $this->CoveragePref = $coveragePref;
        return $this;
    }
    /**
     * Add item to CoveragePref value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref
     */
    public function addToCoveragePref(\dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref) {
            throw new \InvalidArgumentException(sprintf('The CoveragePref property can only contain items of \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CoveragePref[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleReservationRQAdditionalInfoTypeCoveragePref|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CoveragePref
     */
    public function getAttributeName()
    {
        return 'CoveragePref';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleReservationRQAdditionalInfoTypeCoveragePref
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
